<?php

class SocialSQL_DB {
    public static function create_tables() {
        global $wpdb;
        $sources_table_name = $wpdb->prefix . 'socialsql_sources';
        
        if ($wpdb->get_var("show tables like '$sources_table_name'") != $sources_table_name) {
            $query = $wpdb->prepare(
                "CREATE TABLE " . $sources_table_name . " (
                    page_id VARCHAR(255) NOT NULL default '',
                    page_name VARCHAR(255) NOT NULL default '',
                    access_token VARCHAR(512) NOT NULL default '',
                    expires_on DATETIME NOT NULL,
                    last_updated DATETIME NOT NULL,
                    PRIMARY KEY  (page_id)
                ) ENGINE = InnoDB"
            );
            $wpdb->query($query);
		}
    }

    public static function insert_source($source) {
		global $wpdb;
		$sources_table_name = $wpdb->prefix . 'socialsql_sources';
		
		$data = array();
		$format = array();
		if (isset($source['page_id'])) {
			$data['page_id'] = $source['page_id'];
			$format[] = '%s';
		}
		if (isset($source['page_name'])) {
			$data['page_name'] = $source['page_name'];
			$format[] = '%s';
		}
		if (isset($source['access_token'])) {
			$data['access_token'] = $source['access_token'];
			$format[] = '%s';
		}
		if (isset($source['expires_on'])) {
			$data['expires_on'] = $source['expires_on'];
			$format[] = '%s';
		} else {
			$data['expires_on'] = '2088-12-31 00:00:00';
			$format[] = '%s';
		}
		$data['last_updated'] = date('Y-m-d H:i:s');
		$format[] = '%s';

		$result = $wpdb->insert($sources_table_name, $data, $format);

		return $result;
	}

    public static function update_source($source, $where_source) {
		global $wpdb;
		$sources_table_name = $wpdb->prefix . 'socialsql_sources';
		
		$data = array();
		$where = array();
		$format = array();
		$where_format = array();
        // Fields to be updated
		if (isset($source['page_id'])) {
			$data['page_id'] = $source['page_id'];
			$format[] = '%s';
		}
		if (isset($source['page_name'])) {
			$data['page_name'] = $source['page_name'];
			$format[] = '%s';
		}
		if (isset($source['access_token'])) {
			$data['access_token'] = $source['access_token'];
			$format[] = '%s';
		}
		if (isset($source['expires_on'])) {
			$data['expires_on'] = $source['expires_on'];
			$format[] = '%s';
		}
		if (isset($source['last_updated'])) {
			$data['last_updated'] = $source['last_updated'];
			$format[] = '%s';
		}
        // If fields match
		if (isset($where_source['page_id'])) {
			$where['page_id'] = $where_source['page_id'];
			$where_format[] = '%s';
		}

		$result = $wpdb->update( $sources_table_name, $data, $where, $format, $where_format );

		return $result;
	}
	
	public static function delete_source( $source_page_id ) {
		global $wpdb;
		$sources_table_name = $wpdb->prefix . 'socialsql_sources';
		
		$result = $wpdb->delete( $sources_table_name, ['page_id' => $source_page_id], ['%s'] );
        return $result;
	}
    
}

?>