jQuery(function($) {
    $('#socialsql_search_submit').click(function() {
        $('#loader').show();
		// Search for keyword in the selected data set
		var query = $('#socialsql_search_input').val();
		var pageid = $('#socialsql_search_pageid').val();
		var limit = $('#socialsql_search_limit').val();
		var mypost = $('#socialsql_search_mypost').val();

        $.ajax({
			type: 'POST',
			url: socialsqlPageSearch.ajaxurl,
			data: {
			    pageid: pageid,
			    query: query,
			    limit: limit,
			    mypost: mypost,
			    action: 'socialsql_getpagesearch'
			},
			success: function(response) {
				var result = JSON.parse(response);
				$('#socialsql_search_table tbody').empty();
				
				$.each(result, function(key,value) {
					var post_date = moment(value.created_time).format('Do MMM YYYY');
					
					if (value.post_message == null) {
						var post_message = '';
						if (value.sharedposts != null) {
							var sharedpost = [];
							var sp = 0;
							$.each(value.sharedposts, function(k,v) {
								if (v.message != null) {
									sharedpost[sp] = v.message;
									sp++;
								}
							});
							if (sharedpost.length == 0) {
								var attachment = [];
								var at = 0;
								$.each(value.attachments, function(k,v) {
									if (v.url != null) {
										if (v.description != null) {
											attachment[at] = v.description;
										}
										else if (v.title != null) {
											attachment[at] = v.title;
										}
										else if (v.type != null) {
											attachment[at] = v.type;
										}
										at++;
									}
								});
								for (i = 0; i < attachment.length; i++) {
									if (i == attachment.length-1) {
										post_message += attachment[i];
									}
									else {
										post_message += attachment[i] + ', ';
									}
								}
								post_message = 'Attachment post(s): ' + post_message;
							}
							else {
								for (i = 0; i < sharedpost.length; i++) {
									if (i == sharedpost.length-1) {
										post_message += sharedpost[i];
									}
									else {
										post_message += sharedpost[i] + ', ';
									}
								}
								post_message = 'Shared post(s): ' + post_message;
							}
							
						}
						else if (value.attachments != null) {
							var attachment = [];
							var at = 0;
							$.each(value.attachments, function(k,v) {
								if (v.url != null) {
									if (v.description != null) {
										attachment[at] = v.description;
									}
									else if (v.title != null) {
										attachment[at] = v.title;
									}
									else if (v.type != null) {
										attachment[at] = v.type;
									}
									at++;
								}
							});
							for (i = 0; i < attachment.length; i++) {
								if (i == attachment.length-1) {
									post_message += attachment[i];
								}
								else {
									post_message += attachment[i] + ', ';
								}
							}
							post_message = 'Attachment post(s): ' + post_message;
						}
						else {
							post_message = 'No available information';
						}
					}
					else {
						var post_message = value.post_message;
					}
					
					if (value.comments == null) {
						var commentsTable = 'none';
						var tr = '<tr><td><a href="https://www.facebook.com/' + value.post_id + '" target="_blank">' + post_message + '</a></td><td>' + post_date + '</td><td colspan="2">' + commentsTable + '</td></tr>';
							$('#socialsql_search_table tbody').append(tr);
						}
					else {
						var nr = value.comments.length;
						var comment_array = new Array();
						for (j = 0; j < nr; j++) {
							comment_array[j] = new Array();
							comment_array[j].created_time = value.comments[j].created_time;
							if (value.comments[j].message == '' && value.comments[j].attachment) {
								if (value.comments[j].attachment.type == 'animated_image_share' || value.comments[j].attachment.type == 'photo' || value.comments[j].attachment.type == 'sticker') {
										comment_array[j].message = '<a href="' + value.comments[j].attachment.url + '" target="_blank">' + value.comments[j].attachment.type + '</a>';
							    }
							    else if (value.comments[j].attachment.description != null) {
								    comment_array[j].message = value.comments[j].attachment.description;
							    }
							    else if (value.comments[j].attachment.title != null) {
								    comment_array[j].message = value.comments[j].attachment.title;
							    }
							    else {
								    comment_array[j].message = 'No available information';
							    }
						    }
							else {
								comment_array[j].message = value.comments[j].message;
							}
						}
							
						if (nr > 1) {
							var tr = '<tr><td rowspan ="'+nr+'"><a href="https://www.facebook.com/' + value.post_id + '" target="_blank">' + post_message + '</a></td><td rowspan ="'+nr+'">' + post_date + '</td><td>' + comment_array[0].message + '</td><td>' + moment(comment_array[0].created_time).format('Do MMM YYYY') + '</td><td><button class="c-toggle">less</button></td></tr>';
						}
						else {
							var tr = '<tr><td><a href="https://www.facebook.com/' + value.post_id + '" target="_blank">' + post_message + '</a></td><td>' + post_date + '</td><td>' + comment_array[0].message + '</td><td>' + moment(comment_array[0].created_time).format('Do MMM YYYY') + '</td></tr>';
						}
						$('#socialsql_search_table tbody').append(tr);
						$.each(comment_array.slice(1), function(key,value) {
								tr = '<tr><td>' + value.message + '</td><td>' + moment(value.created_time).format('Do MMM YYYY') + '</td></tr>';
								$('#socialsql_search_table tbody').append(tr);
						});
							
					}
				});
				// minimize comments
				$('.c-toggle').trigger('click');
			},
			complete: function() {
				$('#loader').hide();
			}	
		});
	});
	
	$('#socialsql_search_table tbody').on('click', '.c-toggle', function() {
		var row = $(this).closest('tr');
		if ($(row).children('td:first').attr('rowspan')) {
			var nr = parseInt($(row).children('td:first').attr('rowspan'));
			$(row).children('td:first').attr('data-rowspan', nr);
			for (var c = 0; c < 3; c++) {
				$(row).children('td:nth-of-type('+c+')').removeAttr('rowspan');
			}
			$(this).text('more');
		}
		else {
			var nr = parseInt($(row).children('td:first').attr('data-rowspan'));
			for (var c = 0; c < 3; c++) {
				$(row).children('td:nth-of-type('+c+')').attr('rowspan', nr);
			}
			$(row).children('td:first').removeAttr('data-rowspan');
			$(this).text('less');
		}
		for (var i = 1; i < nr ; i++) {
			row.next().toggle();
			row = row.next();
		}
	});
});