<?php

add_action( 'wp_enqueue_scripts', 'socialsql_keywordposts_scripts');

function socialsql_keywordposts_scripts() {
    wp_enqueue_style ('socialsql-style');
}

add_shortcode( 'socialsql_keywordposts', 'keywordposts' );
function keywordposts($atts){
    global $wpdb;
	$table_name = $wpdb->prefix . 'socialsql_sources';
	
    $a = shortcode_atts( array(
        'class' => 'socialsql-style', // 
        'pageid' => '',
		'keyword' => '',
        'width' => '',
      	'limit' => '',
      	'mypost' => 'true',
    ), $atts );
    $pageid = $a['pageid'];
	$width = ($a['width'] == '') ? 500 : $a['width'];  
    $row = $wpdb->get_row( "SELECT * FROM $table_name WHERE page_id = $pageid" );
    // Enable shortcode display only if source was added in admin
    if (!empty($row)) {
      	$posts = json_decode(socialsql_getkeywordposts($pageid, $a['keyword'], $a['limit'], $a['mypost']), true);
        $content = '<div id="fb-posts-block-container">';
      	for ($i = 0; $i < count($posts['post']); $i++) {
        	$content .= '<div class="fb-post-container" style="width:'.$width.'px">
            			<a href="'.$posts['post'][$i]['permalink_url'].'">
            			<div class="fb-post-header">
                        <div class="fb-post-header-img"><img class="skip-lazy" src="'.($posts['post'][$i]['from'] == $posts['page']['name'] ? $posts['page']['picture'] : '').'"></img></div>
                        <div class="fb-post-header-text"><div class="fb-post-header-text-top">'.$posts['post'][$i]['from'].'</div>
                        <div class="fb-post-header-text-bottom">'.socialsql_get_time_ago($posts['post'][$i]['date']).'</div></div>
                        </div>
            			<div class="fb-post-message">'.$posts['post'][$i]['message'].'</div>
                        <div class="fb-post-picture"><img class="skip-lazy" src="'.$posts['post'][$i]['picture'].'"></img></div>
                        <div class="fb-post-footer">
                        <div class="fb-post-footer-1"><i class="fa fa-thumbs-up"></i> '.($posts['post'][$i]['likes'] ? $posts['post'][$i]['likes'] : 0).'</div>
                        <div class="fb-post-footer-2"><i class="fa fa-comment"></i> '.($posts['post'][$i]['comments'] ? $posts['post'][$i]['comments'] : 0).'</div>
                        <div class="fb-post-footer-3"><i class="fa fa-share"></i> '.($posts['post'][$i]['shares'] ? $posts['post'][$i]['shares'] : 0).'</div>
                        </div></a></div>';
        }
      	$content .= '</div>';
        return $content;
    }
}

/* submit handler for add-source-modal */
function socialsql_getkeywordposts($pageid, $keyword, $limit, $mypost) {
  	$post_url = constant('socialsql_server').'/fbapp/api/user/getkeywordposts';
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $post_url);
    curl_setopt($ch, CURLOPT_POST, 1);
    $headers = array(
        "Content-Type: application/json",
    );
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);  
  	$data = '{"pageid": "'.$pageid.'","keyword":"'.$keyword.'","limit":"'.$limit.'","mypost":"'.$mypost.'"}';
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $result = curl_exec($ch);
    curl_close($ch); 
    
    return $result;
}

function socialsql_get_time_ago($time)
{
    $time_difference = time() - strtotime($time);
    if( $time_difference < 1 ) { return 'less than 1 second ago'; }
    $condition = array( 12 * 30 * 24 * 60 * 60 => 'year',
                30 * 24 * 60 * 60 => 'month',
                24 * 60 * 60 => 'day',
                60 * 60 => 'hour',
                60 => 'minute',
                1 => 'second'
    );

    foreach( $condition as $secs => $str )
    {
        $d = $time_difference / $secs;

        if( $d >= 1 )
        {
            $t = round( $d );
            return 'about ' . $t . ' ' . $str . ( $t > 1 ? 's' : '' ) . ' ago';
        }
    }
}

?>