<?php
/**
 * Plugin Name:         SocialSQL
 * Plugin URI:          https://socialsql.com
 * Description:         SocialSQL plugin for Wordpress
 * Version:             0.9.1
 * Requires at least:   5.2
 * Requires PHP:        7.2
 * Author:              nuoem
 * License:             GPL v2 or later
 * License URI:         https://www.gnu.org/licenses/gpl-2.0.html
 */

 /*
{Plugin Name} is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 2 of the License, or
any later version.
 
{Plugin Name} is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with {Plugin Name}. If not, see {URI to Plugin License}.
*/
require_once plugin_dir_path( __FILE__ ) . 'admin/socialsql-db.php';
require_once plugin_dir_path( __FILE__ ) . 'admin/sources-table.php';

/* Definitions */
define('socialsql_server', 'https://apps.socialsql.com');

/* Activation/Deactivation hooks */
function socialsql_plugin_activate() {
  	SocialSQL_DB::create_tables();
    do_action( 'socialsql_plugin_activate' );
}
register_activation_hook( __FILE__, 'socialsql_plugin_activate' );

function socialsql_plugin_deactivate() {
    $timestamp = wp_next_scheduled( 'socialsql_cron_hook' );
    wp_unschedule_event( $timestamp, 'socialsql_cron_hook' );
    do_action( 'socialsql_plugin_deactivate' );
}
register_deactivation_hook( __FILE__, 'socialsql_plugin_deactivate' );

/* Register scripts and styles */
function socialsql_plugin_resource() {
    wp_register_script('socialsql-moment', plugin_dir_url( __FILE__ ).'assets/js/moment.min.js', array('jquery'));
    wp_register_script('socialsql-add-source-modal', plugin_dir_url( __FILE__ ).'admin/js/add-source-modal.js', array('jquery-ui-dialog'));
    wp_register_script('socialsql-sources-table', plugin_dir_url( __FILE__ ).'admin/js/sources-table.js', array('jquery'));
    wp_register_script('socialsql-pagesearch', plugin_dir_url( __FILE__ ).'public/js/pagesearch.js', array('jquery-ui-dialog'));
    wp_register_style('socialsql-style', plugin_dir_url( __FILE__ ) . 'public/css/socialsql.css');
    wp_register_style('socialsql-admin-style', plugin_dir_url( __FILE__ ) . 'admin/css/socialsql-admin.css');
    wp_register_style('socialsql-bootstrap-style', plugin_dir_url( __FILE__ ) . 'assets/css/bootstrap.min.css');
    wp_register_style('socialsql-font-awesome-style', plugin_dir_url( __FILE__ ) . 'assets/css/font-awesome.min.css');
}
add_action( 'init', 'socialsql_plugin_resource' );

include plugin_dir_path( __FILE__ ) . 'admin/admin-page.php';
include plugin_dir_path( __FILE__ ) . 'public/pagesearch.php';
include plugin_dir_path( __FILE__ ) . 'public/keywordposts.php';

?>
